;;==========================================================================
;;    " "
;;

.dseg
msine_SRate:	.byte	1
msine_SkipSpd:	.byte	1
msine_V_L:	.byte	1
msine_V_R:	.byte	1

msine_MainEn:	.byte	1

.eseg
nv_msine_SRate:	.byte	1
nv_msine_SkipSpd:.byte	1
nv_msine_V_L:	.byte	1
nv_msine_V_R:	.byte	1

.cseg
;
;   " "
;
msine_Enter:
 call	f_IO
.db	f_ORead, 4
.dw	nv_msine_SRate
.dw	msine_SRate

 ldi	r16, 'n'
 sts	msine_MainEn, r16

 ldi	r22, low(msine_Desc*2)
 ldi	r23, high(msine_Desc*2)
 call	ur_Menu

 rcall	msine_MainOff
 call	vlsi_Close

 ldi	r16, m_ModeMenu
 sec
 ret

msine_Desc:
 .db	(1<<ur_m_DrawEn) | (1<<ur_m_LeftEn) | (1<<ur_m_OkEn) | (1<<ur_m_RightEn) | (1<<ur_m_SelEn)                                    , 0x00
 .dw	msine_Txt1*2
 .dw	msine_SRateDraw
 .dw	msine_SRateDec
 .dw	msine_SaveTuning
 .dw	msine_SRateInc

 .db	(1<<ur_m_DrawEn) | (1<<ur_m_LeftEn) | (1<<ur_m_OkEn) | (1<<ur_m_RightEn) | (1<<ur_m_SelEn)                                    , 0x00
 .dw	msine_Txt2*2
 .dw	msine_SkipSpdDraw
 .dw	msine_SkipSpdDec
 .dw	msine_SaveTuning
 .dw	msine_SkipSpdInc

 .db	(1<<ur_m_DrawEn) | (1<<ur_m_LeftEn) | (1<<ur_m_OkEn) | (1<<ur_m_RightEn) | (1<<ur_m_SelEn)                                    , 0x00
 .dw	msine_Txt3*2
 .dw	msine_VL_Draw
 .dw	msine_VL_Dec
 .dw	msine_SaveTuning
 .dw	msine_VL_Inc

 .db	(1<<ur_m_DrawEn) | (1<<ur_m_LeftEn) | (1<<ur_m_OkEn) | (1<<ur_m_RightEn) | (1<<ur_m_SelEn)                                    , 0x00
 .dw	msine_Txt4*2
 .dw	msine_VR_Draw
 .dw	msine_VR_Dec
 .dw	msine_SaveTuning
 .dw	msine_VR_Inc

 .db	(1<<ur_m_DrawEn) | (1<<ur_m_LeftEn)                  | (1<<ur_m_RightEn) | (1<<ur_m_SelEn)                                    , 0x00
 .dw	msine_Txt5*2
 .dw	msine_EnDraw
 .dw	msine_MainOff
 .dw	0
 .dw	msine_MainOn

 .db	                                                                           (1<<ur_m_SelEn) | (1<<ur_m_OkFin) | (1<<ur_m_Close), 0x0E
 .dw	msine_Txt6*2
 .dw	0
 .dw	0
 .dw	0
 .dw	0

msine_Txt1:
 .db	"  : ", 0
msine_Txt2:
 .db	" : ", 0
msine_Txt3:
 .db	" : ", 0
msine_Txt4:
 .db	" : ", 0
msine_Txt5:
 .db	"  : ", 0
msine_Txt6:
 .db	" ", 0

;

msine_SRateDraw:
 ldi	ZL, low(msine_SR_Table*2)
 ldi	ZH, high(msine_SR_Table*2)
 clr	r17
 lds	r16, msine_SRate
 swap	r16
 andi	r16, 0x0E
 add	ZL, r16
 adc	ZH, r17
 lpm	dd16uL, Z+
 lpm	dd16uH, Z+
 jmp	DecWordOut

msine_SR_Table:
.dw	44100, 48000, 32000, 22050, 24000, 16000, 11025, 12000

msine_SRateDec:
 lds	r18, msine_SRate
 subi	r18, 0x20
 rjmp	msine_SRD_1

msine_SRateInc:
 lds	r18, msine_SRate
 subi	r18, -0x20
msine_SRD_1:
 andi	r18, 0xE0
 sts	msine_SRate, r18
 rjmp	msine_MainRestart

;

msine_SkipSpdDraw:
 lds	dd16uL, msine_SkipSpd
 jmp	DecByteOut

msine_SkipSpdDec:
 lds	r18, msine_SkipSpd
 dec	r18
 rjmp	msine_SSI_1

msine_SkipSpdInc:
 lds	r18, msine_SkipSpd
 inc	r18
msine_SSI_1:
 andi	r18, 0x1F
 sts	msine_SkipSpd, r18
 rjmp	msine_MainRestart

;

msine_VL_Draw:
 lds	dd16uL, msine_V_L
 com	dd16uL
 jmp	DecByteOut

msine_VL_Dec:
 lds	r16, msine_V_L
 inc	r16
 rjmp	msine_VL_I_1
msine_VL_Inc:
 lds	r16, msine_V_L
 dec	r16
msine_VL_I_1:
 sts	msine_V_L, r16
 rjmp	msine_VR_I_2

;

msine_VR_Draw:
 lds	dd16uL, msine_V_R
 com	dd16uL
 jmp	DecByteOut

msine_VR_Dec:
 lds	r16, msine_V_R
 inc	r16
 rjmp	msine_VR_I_1

msine_VR_Inc:
 lds	r16, msine_V_R
 dec	r16
msine_VR_I_1:
 sts	msine_V_R, r16
msine_VR_I_2:
 rjmp	msine_MainRestart

;

msine_EnDraw:
 lds	r25, msine_MainEn
 call	lcd_CharOut

 clr	r16
 call	lcd_SetAttr

 ldi	r25, ' '
 call	lcd_CharOut
  
 ldi	ZL, low(msine_SR_Table*2)
 ldi	ZH, high(msine_SR_Table*2)
 clr	r17
 lds	r16, msine_SRate
 swap	r16
 andi	r16, 0x0E
 add	ZL, r16
 adc	ZH, r17

 lpm	mc16uL, Z+
 lpm	mc16uH, Z+

 clr	mp16uH
 lds	mp16uL, msine_SkipSpd

 call	mpy16u

 lsl	m16u0
 rol	m16u1
 rol	m16u2
 rol	m16u3

 mov	dd16uL, m16u1
 mov	dd16uH, m16u2
 jmp	DecWordOut

;
;     
;
msine_MainRestart:
 rcall	msine_MainOff

;
;  
;
msine_MainOn:
 ldi	r16, 'Y'
 sts	msine_MainEn, r16

; sbi	DDRB, 1			;   VLSI
; cbi	PORTB, 1
; call	Wait1mks
; sbi	PORTB, 1
; call	Wait2ms

 clr	r17
 ldi	r19, (1<<(vlsi_SM_SDINEW-8))
 ldi	r18, (1<<vlsi_SM_TESTS)
 call	vlsi_CWrite

 ldi	r17, 0x0b		; Volume
 lds	r19, msine_V_L
 lds	r18, msine_V_R
 call	vlsi_CWrite

 call	vlsi_WaitDREQ

 ldi	r16, spi_CSCLK_VLSI_SDI
 call	spi_CSCLK_Select	; !CS = 1, CLKen = 1

 ldi	r16, 0x53
 call	spi_IO
 ldi	r16, 0xEF
 call	spi_IO
 ldi	r16, 0x6E
 call	spi_IO

 lds	r16, msine_SkipSpd
 lds	r17, msine_SRate
 or	r16, r17
 call	spi_IO

 rjmp	msine_MO_1

;
;  
;
msine_MainOff:
 ldi	r16, 'N'
 sts	msine_MainEn, r16

 call	vlsi_WaitDREQ

 ldi	r16, spi_CSCLK_VLSI_SDI
 call	spi_CSCLK_Select	; !CS = 1, CLKen = 1

 ldi	r16, 0x45
 call	spi_IO
 ldi	r16, 0x78
 call	spi_IO
 ldi	r16, 0x69
 call	spi_IO
 ldi	r16, 0x74
 call	spi_IO

msine_MO_1:
 ldi	r17, 4
msine_MO_2:
 clr	r16
 call	spi_IO
 dec	r17
 brne	msine_MO_2
 ret

;
;  
;
msine_SaveTuning:
 call	f_IO
.db	f_OWrite, 4
.dw	nv_msine_SRate
.dw	msine_SRate

 clc
 call	lcd_PrintC
.db	"Saved to EEPROM", 1
 ret
